var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { useMemo } from 'react';
import { GraphqlWatchQueryStore, } from '@proscom/prostore-apollo';
import { useRequestStore } from '@proscom/prostore-react';
import { useContextApolloClient } from './ApolloClientsContext';
/**
 * Создает graphql watchQuery и подписывается на него
 * @param client - Apollo Client instance
 * @param queryOptions - Параметры запроса
 * @param variables - Переменные запроса
 * @returns {{load, check, state}} - Состояние запроса
 */
export function useGraphqlWatchQuery(_a) {
    var client = _a.client, queryOptions = _a.queryOptions, variables = _a.variables;
    var actualClient = useContextApolloClient(client);
    var store = useMemo(function () {
        return new GraphqlWatchQueryStore(__assign({ client: actualClient }, queryOptions));
    }, [actualClient, queryOptions]);
    return useRequestStore(store, variables);
}
export function useGraphqlWatchQueryVars(_a) {
    var variableCreator = _a.variableCreator, queryProps = __rest(_a, ["variableCreator"]);
    var variables = useMemo.apply(void 0, variableCreator);
    return useGraphqlWatchQuery(__assign({}, queryProps, { variables: variables }));
}
//# sourceMappingURL=useGraphqlWatchQuery.js.map