import { DependencyList } from 'react';
import { IGraphqlWatchQueryStoreParams } from '@proscom/prostore-apollo';
import { ApolloClient } from 'apollo-client';
export interface IUseGraphqlWatchQueryParams<Vars, Data> {
    client?: string | ApolloClient<any>;
    queryOptions?: IGraphqlWatchQueryStoreParams<Vars, Data>;
    variables?: Vars;
}
/**
 * Создает graphql watchQuery и подписывается на него
 * @param client - Apollo Client instance
 * @param queryOptions - Параметры запроса
 * @param variables - Переменные запроса
 * @returns {{load, check, state}} - Состояние запроса
 */
export declare function useGraphqlWatchQuery<Vars, Data>({ client, queryOptions, variables }: IUseGraphqlWatchQueryParams<Vars, Data>): import("@proscom/prostore-react").UseRequestStoreResult<import("@proscom/prostore").IRequestState<Vars, Data>>;
export interface IUseGraphWatchQueryVarsParams<Vars, Data> extends IUseGraphqlWatchQueryParams<Vars, Data> {
    variableCreator: [() => Vars, DependencyList];
}
export declare function useGraphqlWatchQueryVars<Vars, Data>({ variableCreator, ...queryProps }: IUseGraphWatchQueryVarsParams<Vars, Data>): import("@proscom/prostore-react").UseRequestStoreResult<import("@proscom/prostore").IRequestState<Vars, Data>>;
